extends Area2D

######################################################
#            2018-01-13 acodemia.pl                  #
# Skrypt reprezentuje funkcjonalność bomby           #
# z opóźnionym zapłonem                              #
######################################################

export (float) var time_to_armed = 2
export (float) var time_to_explode = 3
export (bool) var random_time_settings = false
const TIME_RANDOM_START = 1
const TIME_RANDOM_STOP = 5


func _ready():
	randomize()
	if(random_time_settings):
		time_to_armed = rand_range(TIME_RANDOM_START, TIME_RANDOM_STOP)
		time_to_explode = rand_range(TIME_RANDOM_START, TIME_RANDOM_STOP)
	get_node("AnimationPlayer").play("animation_green")
	get_node("TimerGreen").stop()
	get_node("TimerRed").stop()
	get_node("TimerGreen").set_wait_time(time_to_armed)
	get_node("TimerRed").set_wait_time(time_to_explode)
	get_node("TimerGreen").start()
	pass

func _fixed_process(delta):
	pass

func _on_TimeBomb_body_enter( body ):
	print("Any Body in zone...")
	pass

func _on_TimerGreen_timeout():
	get_node("AnimationPlayer").play("animation_red")
	get_node("TimerGreen").stop()
	get_node("TimerRed").start()
	pass


func _on_TimerRed_timeout():
	explode()
	get_node("TimerRed").stop()
	queue_free()
	pass

func explode():
	var bomb_explosion = preload("bomb_explosion/BombExplode.tscn").instance()
	bomb_explosion.set_pos(get_pos())
	bomb_explosion.set_scale(self.get_scale())
	get_node("../").add_child(bomb_explosion)
	pass
